<?php
namespace Models;

class Fr_php {
	public $f3, $sets, $web, $config;

    protected $electronically=array(true, false);

	protected $tax=array( // Налог
		1=>'vat0', // НДС 0
        2=>'vat10', // НДС 10 выделить
        3=>'vat20', // НДС 20 выделить
        4=>'none', // Без НДС
        5=>'vat110', // НДС 10 начислить
        6=>'vat120' // НДС 20 начислить
	);

	protected $paymentObject=array( // Признак предмета расчета
		1=>'commodity', // товар
        2=>'excise', // подакцизный товар
        3=>'job', // работа
        4=>'service', // услуга
        5=>'gamblingBet',  // ставка азартной игры
        6=>'gamblingPrize', // выигрыш азартной игры
        7=>'lottery', // лотерейный билет
        8=>'lotteryPrize', // выигрыш лотереи
        9=>'intellectualActivity', // предоставление результатов интерелектуальной деятельности
        10=>'payment', // платеж
        11=>'agentCommission', // агентское вознаграждение
        12=>'composite', // составной предмет расчета
        13=>'another', // иной предмет расчета
        14=>'proprietaryLaw', // имущественное право
        15=>'nonOperatingIncome', // внереализационный доход
        16=>'otherContributions', // иные платежи и взносы
        17=>'merchantTax', // торговый сбор
        18=>'resortFee', // курортный сбор
        19=>'deposit', // залог
        20=>'consumption', // расход
        21=>'soleProprietorCPIContributions', // взносы на ОПС ИП
        22=>'cpiContributions', // взносы на ОПС
        23=>'soleProprietorCMIContributions', // взносы на ОМС ИП
        24=>'cmiContributions', // взносы на ОМС
        25=>'csiContributions', // взносы на ОСС
        26=>'casinoPayment' // платеж казино
	);

	protected $paymentMethod=array( // Признак способа расчета
		1=>'fullPrepayment', // предоплата 100%
        2=>'prepayment', // предоплата
        3=>'advance', // аванс
        4=>'fullPayment', // полный расчет
        5=>'partialPayment', // частичный расчет и кредит
        6=>'credit', // передача в кредит
        7=>'creditPayment' // оплата кредита
	);
	
	function __construct($f3, $sets) {
		$this->f3=$f3;
		$this->sets=$sets;
		$this->web=\Web::instance();
		$this->config=parse_ini_file($sets['driver'].'/server.config'); // Настройки драйвера
	}

	function kkm_init() {
		/*$data=array(
			'type'=>'setDeviceParameters',
			'deviceParameters'=>array(
				array(
					'key'=>19,
					'value'=>1
				),
				array(
					'key'=>62,
					'value'=>1
				)
			)
		);
		$uuid=uniqid(); // id задания
		$options = $this->options($uuid, $data);
		// Оотправляем запрос
		$res=$this->send_task($options);
		// Проверка выполнения задания
		$res=$this->check_task($uuid);
		if(!$res['success']) {
			echo $res['error'];
			echo $continue_html= \Template::instance()->render('fr_error_continue.htm');
			exit();
		}*/
		$this->f3->set('SESSION.drivers_init', 1);
	}

	// Формирование данных для отправки
	function options($uuid, $data, $timeout=3) {
		$options = array( // Данные для отправки на сервер
			'timeout'=>$timeout,
			'headers'=>array(
				'Content-Type: application/json'
			),
    		'method'  => 'POST',
    		'content'=>json_encode(
    			array(
    				'uuid'=>$uuid,
    				'request'=>$data
    			)
    		)
		);

		return $options;
	}

	// Отправка задания
	function send_task($options) {
		$url=$this->sets['url'].'/requests';
		$res=$this->web->request($url, $options);
		return $res;
	}

	function check_task($uuid) {
		$url=$this->sets['url'].'/requests/'.$uuid;
		$options=array(
			'timeout'=>3,
			'method'=>'GET'
		);
		// Ждем выполнения задания
		$ok=false;
		$n=100000;
		for($i=0; $i<$n; $i++) {
			usleep(300000);
			$res=$this->web->request($url, $options);
			if(mb_strpos($res['headers'][0], '200')===false) {
				echo "<p class='false'>Нет связи</p>";
				exit();
			}
			$json=json_decode($res['body'], true);
			// Проверяем результаты заданий
			$ready=0;
			foreach ($json['results'] as $r) {
				if($r['status']=='ready') { // Задание выполнено
					$ready=1;
				}
				if($r['status']=='wait' || $r['status']=='inProgress') { // Задание ждет очереди или еще выполняется
					$ready=0;
				}
				if($r['status']=='error') { // Ошибка выполнения задания, дальше ничего не выполнится
					$i=$n;
					$ready=0;
					break;
				}
			}
			if($ready==1) {
				$i=$n;
				$ok=true;
			}
		}

		$error='';
		if($ok===false) { // Вывод ошибок
			foreach ($json['results'] as $r) {
				$error.='<p class="false">'.$r['errorDescription'].'</p>';
			}
		}
		return array(
			'success'=>$ok,
			'error'=>$error,
			'results'=>$json['results']
		);
	}

	// Выводим статус ККМ в понятном виде
	function deviceStatus($data) {
		$p=array(
			'currentDateTime'=>array('title'=>'Текущие дата и время'),
			'shift'=>array(
				'title'=>'Состояние смены',
				'values'=>array(
					'closed'=>'закрыта',
					'opened'=>'открыта',
					'expired'=>'истекла'
				)
			),
			'blocked'=>array('title'=>'ККТ заблокирована'),
			'coverOpened'=>array('title'=>'Крышка открыта'),
			'paperPresent'=>array('title'=>'Наличие чековой ленты'),
			'fiscal'=>array('title'=>'ККТ зарегистрирована'),
			'fnFiscal'=>array('title'=>'ФН фискализирован'),
			'fnPresent'=>array('title'=>'ФН обнаружен'),
			'cashDrawerOpened'=>array('title'=>'Денежный ящик открыт')
		);
		foreach ($data as $key => $value) {
			if(isset($p[$key])) {
				if($value===false) $v='Нет';
				elseif($value===true) $v='Да';
				elseif(isset($p[$key]['values'][$value])) $v=$p[$key]['values'][$value];
				else $v=$value;
				echo '<p><b>'.$p[$key]['title'].'</b> - '.$v.'</p>';
			}
			else {
				echo '<p><b>'.$key.'</b> - '.$value.'</p>';
			}
		}
	}

	// Отправка запроса
	function send_ajax($strs, $timeout=3, $view=false) {
		if(!$this->f3->get('SESSION.drivers_init') || true) {
			$this->kkm_init();
		}
		$data=$this->wtf($strs);
		if(!$data) {
			echo '<p class="false">'.$strs.'<br>Команда не поддерживается</p>';
			exit();
		}
		$uuid=uniqid(); // id задания
		$options = $this->options($uuid, $data);
		// Оотправляем запрос
		$res=$this->send_task($options);
		// Проверка выполнения задания
		$res=$this->check_task($uuid);
		if(!$res['success']) {
			echo $strs.'<br>';
			echo $res['error'];
			//exit();
		}
		if($view) {
			foreach ($res['results'] as $key=>$r) {
				if(isset($r['result']['deviceStatus'])) {
					$this->deviceStatus($r['result']['deviceStatus']);
				}
				elseif($r['result']) {
					var_dump($r['result']);
				}
				echo '<p class="true">'.$r['errorDescription'].'</p>';
			}
		}
		if(!$res['success'] && !$view) {
			echo $continue_html= \Template::instance()->render('fr_error_continue.htm');
			exit();
		}
	}

	// Информация о ККМ
	function getDeviceInfo() {
		$data=array(
			'type'=>'getDeviceInfo'
		);
		$uuid=uniqid(); // id задания
		$options = $this->options($uuid, $data);
		// Отправляем запрос
		$res=$this->send_task($options);
		// Проверка выполнения задания
		$res=$this->check_task($uuid);
		if(!$res['success']) {
			echo $res['error'];
			exit();
		}
		return $res['results'][0]['result']['deviceInfo'];
	}

    // Узнаем состояние смены
    function change_status() {
        $data=array(
            'type'=>'getShiftStatus'
        );
        $uuid=uniqid(); // id задания
        $options = $this->options($uuid, $data);
        // Отправляем запрос
        $res=$this->send_task($options);
        // Проверка выполнения задания
        $res=$this->check_task($uuid);
        if(!$res['success']) {
            echo $res['error'];
            exit();
        }
        $status=$res['results'][0]['result']['shiftStatus']['state'];
        // closed - закрыта
        // opened - открыта
        // expired - истекла
        return $status;
    }

	// Узнать ширину бумаги
	function get_width() {
		if($this->config['PaperWidth']>0) {
			return $this->config['PaperWidth'];
		}
		$info=$this->getDeviceInfo();
		$this->config['PaperWidth']=$info['receiptLineLength'];
		return $info['receiptLineLength'];
	}

	// Форматирование текста
    function text_format($s, $w=null) {
        if(!$w)$w=$this->get_width();
        $s=str_replace('#kkm_bold#', '', $s);
        // Заменяем #kkm_right# на пробелы
        $kkm_right="#kkm_right#"; # тэг сдвига вправо
        $space_n=$w-(mb_strlen($s)-mb_strlen($kkm_right)); // кол-во пробелов
        $s=str_replace($kkm_right, str_repeat(" ", $space_n), $s); // заменяем тэг сдвига на пробелы

        // Заменяем #kkm_center# на пробелы
        $kkm_center="#kkm_center#"; // тэг сдвига в центр
        $space_n=floor(($w-(mb_strlen($s)-mb_strlen($kkm_center)))/2); // кол-во пробелов
        $s=str_replace($kkm_center, str_repeat(" ", $space_n), $s); // заменяем тэг сдвига на пробелы
        return $s;
    }

	// Что надо выполнить
	function wtf($strs) {
		$str=explode("\n", $strs);
		$ticket=false;
		$i=0;
		foreach ($str as $s) {
			$items=array();
			$s=trim($s);
        	$p=explode(';', $s);
        	$n=count($p);
        	if($p[$n-1]=='') {
            	unset($p[$n-1]);
            	$n-=1;
        	}
        	if($s=='') continue;
        	if($p[0]=='beep') { // Гудок
        		$data[$i]=array(
        			'type'=>'nonFiscal',
        			'items'=>array(
        				array(
        					'type'=>'text',
        					'text'=>'Бип-бип-бип! Твой сигналит джип'
        				)
        			),
        			'printFooter'=>false
        		);
        	}
        	elseif($p[0]=='feed') { // Протяжка
	           for($j=0; $j<$p[1]; $j++) {
    	        	$items[]=array(
        				'type'=>'text',
        				'text'=>' '
            		);
	            }
    	        $data[$i]=array(
        			'type'=>'nonFiscal',
        			'items'=>$items,
        			'printFooter'=>false
        		);
        	}
        	elseif($p[0]=='open_session') { // Открытие смены
                if(!isset($p[1]))$p[1]=1;
            	$data[$i]=array(
	            	'type'=>'openShift',
                    'electronically'=>$this->electronically[$p[1]]
    	        );
        	}
        	elseif($p[0]=='z') { // Закрытие смены
                if(!isset($p[1]))$p[1]=1;
            	$data[$i]=array(
            		'type'=>'closeShift',
                    'electronically'=>$this->electronically[$p[1]]
            	);
        	}
        	elseif ($p[0]=='p' || $p[0]=='pm') { // Печать текста
        		$txt=explode('#kkm_br#',$p[1]);
        		foreach ($txt as $t) {
        			$items[]=array(
        				'type'=>'text',
        				'text'=>$this->text_format($t),
        				'wrap'=>'none'
            		);
        		}
        		$data[$i]=array(
        			'type'=>'nonFiscal',
        			'items'=>$items,
        			'printFooter'=>false
        		);
        	}
        	elseif($p[0]=='print_font') { // Печать строки заданным размером шрифта
        		$txt=explode('#kkm_br#',$p[1]);
        		$w=$this->get_width();
        		$double_width=false;
        		$double_height=false;
        		if($p[2]>4)$p[2]=4;
				if($p[2]==2) {
        			$double_width=true;
        			$w/=2;
        		}
        		elseif($p[2]==3) {
        			$double_height=true;
        		}
        		elseif($p[2]==4) {
        			$double_width=true;
        			$double_height=true;
        			$w/=2;
        		}
        		foreach ($txt as $t) {
        			$items[]=array(
        				'type'=>'text',
        				'text'=>$this->text_format($t, $w),
        				'wrap'=>'none',
        				'doubleWidth'=>$double_width,
        				'doubleHeight'=>$double_height,
            		);
        		}
        		$data[$i]=array(
        			'type'=>'nonFiscal',
        			'items'=>$items,
        			'printFooter'=>false
        		);
        	}
        	elseif($p[0]=='print_bold') { // Печать жирной строки
        		$txt=explode('#kkm_br#',$p[1]);
        		$w=$this->get_width()/2;
        		foreach ($txt as $t) {
        			$items[]=array(
        				'type'=>'text',
        				'text'=>$this->text_format($t, $w),
        				'wrap'=>'none',
        				'doubleWidth'=>true,
        				'doubleHeight'=>true,
            		);
        		}
        		$data[$i]=array(
        			'type'=>'nonFiscal',
        			'items'=>$items,
        			'printFooter'=>false
        		);
        	}
        	elseif($p[0]=='x') { // X отчет
        		$data[$i]=array(
        			'type'=>'reportX'
        		);
        	}
        	elseif($p[0]=='continue_print') { // Продолжить печать чека
        		$data[$i]=array(
        			'type'=>'continuePrint'
        		);
        	}
        	elseif($p[0]=='c') { // Печать копии последнего чека
        		$data[$i]=array(
        			'type'=>'printLastReceiptCopy'
        		);
        	}
        	elseif($p[0]=='d') { // Статус ККМ
            	$data[$i]=array(
        			'type'=>'getDeviceStatus'
        		);
        	}
        	elseif($p[0]=='imde') { // Внесенеи или изъятие из кассы
        		$type='cashIn';
        		if($p[1]<0)$type='cashOut';
        		$data[$i]=array(
        			'type'=>$type,
        			'cashSum'=>abs($p[1]/100)
        		);
        	}
        	elseif($p[0]=='b') { // Открытие чека
        		$ticket=true;
        		$types=array('sell', 'sellReturn');
        		$data[$i]=array(
        			'type'=>$types[$p[1]],
        			'ignoreNonFiscalPrintErrors'=>true,
        			'electronically'=>$this->electronically[$p[3]],
        			'operator'=>array(
        				'name'=>$p[2]
        			)
        		);
        	}
        	elseif($p[0]=='set_tlv' && $p[1]==1008 && $ticket===true) { // Добавление в чек покупателя
        		$data[$i]['clientInfo']=array(
        			'emailOrPhone'=>$p[3]
        		);
        	}
        	elseif($p[0]=='smde' && $ticket===true) { // Добавление товара в чек
        		if(!$p[6])$p[6]=1;
        		if(!$p[7])$p[7]=1;
        		$p[2]/=100;
        		$p[3]/=1000;
        		$data[$i]['items'][]=array(
        			'type'=>'position',
        			'name'=>$p[1],
        			'price'=>$p[2],
        			'quantity'=>$p[3],
        			'amount'=>$p[2]*$p[3],
        			'department'=>(int)$p[5],
        			'paymentMethod'=>$this->paymentMethod[$p[6]],
        			'paymentObject'=>$this->paymentObject[$p[7]],
        			'tax'=>array(
        				'type'=>$this->tax[$p[4]]
        			)
        		);
        	}
        	elseif($p[0]=='tmde' && $ticket===true) { // Оплата чека
        		if(count($p)==3) { // передан 1 способ оплаты ФФД 1.05
        			$data[$i]['payments'][]=array(
        				'type'=>$p[2],
        				'sum'=>$p[1]/100
        			);
        		}
        		else { // Несколько способов оплаты
        			if(count($p)==7) $end=4;
        			else $end=5;
        			for($j=0; $j<$end; $j++) {
        				$data[$i]['payments'][]=array(
        					'type'=>$j,
        					'sum'=>$p[$j+1]/100
        				);
        			}
        		}
        		$ticket=false;
        	}
        	elseif($p[0]=='open_cash_box') { // открыть денежный ящик
        		$data[$i]=array(
        			'type'=>'openCashDrawer'
        		);
        	}

        	if($ticket===false) {
        		$i++;
        	}
        }
        return $data;
	}
}
